b862cc133c6a9e9f618d6ba6f8ed8e3bd09c0f55
[osm/openvim.git] / scripts / install-openvim-service.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openvim
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED for Ubuntu 16.04
25 #it configures openvim to run as a service
26
27 function usage(){
28 echo -e "usage: sudo $0 [OPTIONS]"
29 echo -e "Configures openvim to run as a service at /opt"
30 echo -e " OPTIONS"
31 echo -e " -u USER_OWNER user owner of the service, 'root' by default"
32 echo -e " -f PATH path where openvim source is located. If missing it is downloaded from git"
33 echo -e " -d --delete: if -f is provided, delete this path after copying to /opt"
34 echo -e " -h: show this help"
35 echo -e " --uninstall: remove created service and files"
36 }
37
38 function uninstall(){
39 echo "systemctl disable openvim.service " && systemctl disable openvim.service 2>/dev/null || echo " Already done"
40 echo "service openvim stop " && service openvim stop 2>/dev/null || echo " Already done"
41 for file in /opt/openvim /etc/default/openvimd.cfg /var/log/openvim /etc/systemd/system/openvim.service /usr/bin/openvim /usr/bin/initopenvim /usr/sbin/service-openvim /usr/bin/openvim-report /usr/bin/openflow
42 do
43 rm -rf $file || ! echo "Can not delete '$file'. Needed root privileges?" >&2 || exit 1
44 done
45 echo "Done"
46 }
47
48 BAD_PATH_ERROR="Path '$FILE' does not contain a valid openvim distribution"
49 GIT_URL=https://osm.etsi.org/gerrit/osm/openvim.git
50 USER_OWNER="root"
51 QUIET_MODE=""
52 FILE=""
53 DELETE=""
54 while getopts ":u:f:hdq-:" o; do
55 case "${o}" in
56 u)
57 export USER_OWNER="$OPTARG"
58 ;;
59 f)
60 export FILE="$OPTARG"
61 ;;
62 q)
63 export QUIET_MODE=yes
64 ;;
65 h)
66 usage && exit 0
67 ;;
68 d)
69 DELETE=y
70 ;;
71 -)
72 [ "${OPTARG}" == "help" ] && usage && exit 0
73 [ "${OPTARG}" == "uninstall" ] && uninstall && exit 0
74 [ "${OPTARG}" == "delete" ] && DELETE=y && continue
75 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
76 exit 1
77 ;;
78 \?)
79 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
80 exit 1
81 ;;
82 :)
83 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
84 exit 1
85 ;;
86 *)
87 usage >&2
88 exit -1
89 ;;
90 esac
91 done
92 BAD_PATH_ERROR="Path '$FILE' does not contain a valid openvim distribution"
93
94 #check root privileges
95 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
96
97 #Discover Linux distribution
98 #try redhat type
99 if [[ -f /etc/redhat-release ]]
100 then
101 _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
102 else
103 #if not assuming ubuntu type
104 _DISTRO=$(lsb_release -is 2>/dev/null)
105 fi
106 if [[ "$_DISTRO" == "Ubuntu" ]]
107 then
108 _RELEASE=$(lsb_release -rs)
109 if [[ ${_RELEASE%%.*} != 16 ]]
110 then
111 echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1
112 fi
113 else
114 echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1
115 fi
116
117
118 if [[ -z $FILE ]]
119 then
120 FILE=__temp__${RANDOM}
121 git clone $GIT_URL $FILE || ! echo "Cannot get openvim source code from $GIT_URL" >&2 || exit 1
122 DELETE=y
123 #git checkout <tag version>
124 else
125 [[ -d "$FILE" ]] || ! echo $BAD_PATH_ERROR >&2 || exit 1
126 fi
127
128 #make idenpotent
129 uninstall
130 #copy files
131 cp -r "$FILE" /opt/openvim || ! echo $BAD_PATH_ERROR >&2 || exit 1
132 mkdir -p /opt/openvim/logs
133 #makes links
134 ln -s -v /opt/openvim/openvimd.cfg /etc/default/openvimd.cfg || echo "warning cannot create link '/etc/default/openvimd.cfg'"
135 ln -s -v /opt/openvim/logs /var/log/openvim || echo "warning cannot create link '/var/log/openvim'"
136 ln -s -v /opt/openvim/openvim /usr/bin/openvim
137 ln -s -v /opt/openvim/scripts/service-openvim /usr/sbin/service-openvim
138 ln -s -v /opt/openvim/scripts/openvim-report /usr/bin/openvim-report
139 ln -s -v /opt/openvim/scripts/initopenvim.sh /usr/bin/initopenvim
140 ln -s -v /opt/openvim/openflow /usr/bin/openflow
141
142 chown -R $SUDO_USER /opt/openvim
143
144 mkdir -p /etc/systemd/system/
145 cat > /etc/systemd/system/openvim.service << EOF
146 [Unit]
147 Description=openvim server
148
149 [Service]
150 User=${USER_OWNER}
151 ExecStart=/opt/openvim/openvimd -c /opt/openvim/osm_openvim/openvimd.cfg --log-file=/opt/openvim/logs/openvim.log
152 Restart=always
153
154 [Install]
155 WantedBy=multi-user.target
156 EOF
157
158 [[ -n $DELETE ]] && rm -rf $FILE
159
160 service openvim start
161 systemctl enable openvim.service
162
163 echo Done
164 exit